angular.module('likes.controllers', []).controller('LikesCtrl', function($scope,$ionicHistory,$rootScope,$http,$state,$window, $timeout,$ionicPopup,$ionicLoading, $ionicFilterBar, ionicMaterialMotion, ionicMaterialInk) {

	var pageno = 1;
	var category = '';
	var currentPage = 1;
	var lastPage = 1;

	$scope.data= {category: 1,searchText: '',text: ''};

	var likes = [];
	var movies = [];
	var books = [];

	$scope.isSearch = false;

	var searchText = "";


	$scope.showFilterBar = function () {
		filterBarInstance = $ionicFilterBar.show({
			// items: $scope.items,
			debounce: true,
			delay: 2000,
			update: function (filteredItems, filterText) {
				// $scope.items = filteredItems;
				if (filterText) {
					console.log(filterText);
				}
				if(name == undefined){
					name = "";
					searchText = "";
				}

				$http.get(url + "likesearch?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category + "&name=" + filterText).then(function(items) {
					var temp = [];
					currentPage = items.data.current_page;
					lastPage = items.data.last_page;
					for(var i = 0;i<items.data.data.length;i++){
						items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
						temp.push(items.data.data[i]);
					}
					$scope.items = temp;
				},function(err){
					console.log('Error');
				});
			}
		});
	};

	$scope.searchList = function(){

		var filterText = $scope.data.searchText;
		if(filterText != undefined && filterText != null && filterText != ''){
			$scope.isSearch = true;
			$http.get(url + "likesearch?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category + "&name=" + filterText).then(function(items) {
				var temp = [];
				currentPage = items.data.current_page;
				lastPage = items.data.last_page;
				for(var i = 0;i<items.data.data.length;i++){
					items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
					temp.push(items.data.data[i]);
				}
				$scope.items = temp;
			},function(err){
				console.log('Error');
			});
			$scope.isSearch = true;
		}else{
			pageno = 1;
			currentPage = 1;
			lastPage = 1;
			$http.get(url + "likelist?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category).then(function(items) {
				var temp = [];
				currentPage = items.data.current_page;
				lastPage = items.data.last_page;
				for(var i = 0;i<items.data.data.length;i++){
					items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
					temp.push(items.data.data[i]);
				}
				$scope.items = temp;
			},function(err){
				console.log('Error');
			});
			$scope.isSearch = false;
		}
	};

	$scope.liked = function(id,name,group){
		var result = {"fb_id":id, "name":name,"group":group};
		if(group == 1){
			likes = pushArray(likes, result);
		}else if(group == 2){
			movies = pushArray(movies, result);
		}else if(group == 4){
			books = pushArray(books, result);
		}
	};

	var findPositioninArray = function(arr,id){
		for(var i=0; i<arr.length; i++){
			if(arr[i].fb_id == id){
				return i;
			}
		}
		return -1;
	}

	$scope.disliked = function(id,name,group){
		var l = findPositioninArray(likes,id);
		if(l != -1)
			likes.splice(l,1);

		var m = findPositioninArray(movies,id);
		if(m != -1)
			movies.splice(m,1);

		var b = findPositioninArray(books,id);
		if(b != -1)
			books.splice(b,1);
	};

	$scope.alreadyLiked = function(id){
		for(var i = 0; i < likes.length; i++){
			if(likes[i].fb_id == id)
				return true;
		}

		for(var j = 0; j < movies.length; j++){
			if(movies[j].fb_id == id)
				return true;
		}

		for(var k = 0; k < books.length; k++){
			if(books[k].fb_id == id)
				return true;
		}

		return false;
	};

	var pushArray = function(arr, jvalue){
		var tf = false;
		for(var i = 0; i< arr.length; i++){
			if(arr[i].fb_id == jvalue.fb_id){
				tf = true;
				break;
			}
		}
		if(!tf)
			arr.push(jvalue);

		return arr;
	}

	$scope.requestLikes = function(){
		var myPopup = $ionicPopup.show({
				template: '<input type="text" ng-model="data.text">',
				title: 'Request page',
				subTitle: 'Provide the complete text that you were searching for, we would add it in our database.',
				scope: $scope,
				buttons: [
				{ 
					text: '<i class="fa fa-times"></i>',
					onTap: function(e){
							myPopup.close();
						}
				},
				{
				 text: '<i class="fa fa-check"></i>',
				 type: 'button-positive',
				 onTap: function(e) {
						console.log('password ' + $scope.data.text);
						$http.get(url + "requestlikes?apiKey="+ apiKey + "&fbid=" + user.user_fb_id + "&userid=" + user.id + "&ddlinterests=" + $scope.data.text).then(function(items) {
							console.log(items);
						},function(err){
							console.log('Error');
						});
					}
				}
				]
			});
	};

	$scope.catchange = function(value){
		pageno = 1;
		currentPage = 1;
		lastPage = 1;
		category = value;
		if(value != "" && value != " "){
			$http.get(url + "likelist?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + value).then(function(items) {
				var temp = [];
				currentPage = items.data.current_page;
				lastPage = items.data.last_page;
				for(var i = 0;i<items.data.data.length;i++){
					items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
					temp.push(items.data.data[i]);
				}
				$scope.items = temp;
			},function(err){
				console.log('Error');
			});
			$scope.isSearch = false;
		}else{
			$scope.items = [];
		}
	}

	$scope.loadMoreLikes = function(){
		if(category != "" && category != " " && currentPage < lastPage){
			var filterText = $scope.data.searchText;
			pageno = pageno + 1;
			if(filterText != undefined && filterText != null && filterText != ''){
				$http.get(url + "likesearch?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category + "&name=" + filterText).then(function(items) {
					var temp = [];
					var temparr = $scope.items;
					currentPage = items.data.current_page;
					lastPage = items.data.last_page;
					for(var i = 0;i<items.data.data.length;i++){
						items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
						temp.push(items.data.data[i]);
					}
					$scope.items = temparr.concat(temp);
					$scope.$broadcast('scroll.infiniteScrollComplete');
				},function(err){
					pageno = pageno - 1;
					console.log('Error');
					$scope.$broadcast('scroll.infiniteScrollComplete');
				});
			}else{
				$http.get(url + "likelist?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category).then(function(items) {
					var temp = [];
					var temparr = $scope.items;
					currentPage = currentPage+1;//items.data.current_page;
					lastPage = items.data.last_page;
					// console.log(JSON.stringify(items.data.data));
					for(var i = 0;i<items.data.data.length;i++){
						items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
						temp.push(items.data.data[i]);
					}
					$scope.items = temparr.concat(temp);
					$scope.$broadcast('scroll.infiniteScrollComplete');
				},function(err){
					pageno = pageno - 1;
					console.log('Error');
					$scope.$broadcast('scroll.infiniteScrollComplete');
				});
			}
		}else{
			$scope.$broadcast('scroll.infiniteScrollComplete');
			console.log('loadMoreLikes else');
		}
	};

    var filterBarInstance;

	$scope.initCall = function(){
		category = 1;
		$http.get(url + "mylikes?apiKey="+ apiKey + "&user_fb_id=" + user.user_fb_id).then(function(items) {
			likes = items.data.likes;
			movies = items.data.movies;
			books = items.data.books;
			$http.get(url + "likelist?apiKey="+ apiKey + "&pageno=" + pageno + "&category=" + category).then(function(items) {
				var temp = [];
				currentPage = items.data.current_page;
				lastPage = items.data.last_page;
				// console.log(JSON.stringify(items.data.data));
				for(var i = 0;i<items.data.data.length;i++){
					items.data.data[i].imgUrl = 'http://graph.facebook.com/' + items.data.data[i].fb_id + '/picture?type=square&height=100&width=100';
					temp.push(items.data.data[i]);
				}
				$scope.items = temp;
			},function(err){
				console.log('Error ' + err);
			});
		},function(err){
			console.log('mylikes Error ' + err);
		});
		$scope.isSearch = false;
	};

	$scope.updateLikes = function(){
		/*if(likes.length >= 5 && movies.length >= 5 && books.length >= 5){*/
			$rootScope.$broadcast('loading:show');
			var fd = new FormData($('#save_likes')[0]);
	
			fd.append("apiKey",apiKey);
			fd.append("data",JSON.stringify({"userid": user.user_fb_id,"likes": likes,"movies": movies, "books": books}));
			// }
			var xhr = new XMLHttpRequest();
	
			xhr.upload.addEventListener("progress", function(evt){}, false);
			xhr.addEventListener("load", function(evt){
				$rootScope.$broadcast('loading:hide');
				if(evt.target.responseText == "true"){
					console.log("True " + evt.target.responseText);
					//matchCall();
					isviaregistration = true;
					isBlocked(getFbID());
					//$state.go("home.matches");
				}else if(evt.target.responseText == "limit"){
					console.log("Limit " + evt.target.responseText);
				}else if(evt.target.responseText == "false"){
					console.log("False " + evt.target.responseText);
				}
			}, false);
			xhr.addEventListener("error", function(evt){$rootScope.$broadcast('loading:hide');}, false);
			xhr.addEventListener("abort", function(evt){$rootScope.$broadcast('loading:hide');}, false);
			xhr.open("POST", url + "likesave");
			//scope.progressVisible = true;
			xhr.send(fd);
		/*}else{
			$ionicLoading.show({template: 'Please select minimum 5 under each category to proceed.', duration:2000});
		}*/
	};

    $timeout(function() {
        ionicMaterialMotion.slideUp({
            selector: '.slide-up'
        });
    }, 300);

    $timeout(function() {
        ionicMaterialMotion.fadeSlideInRight({
            startVelocity: 3000
        });
    }, 700);

    // Set Ink
    ionicMaterialInk.displayEffect();
});