angular.module('webapi.factories', []).factory('imageURLFactory',function(){

  return{
    getImageUrl: function(pImg,id){
      // profile_image
      if(pImg==1)
        return imgBaseUrl+"pro_pic/usr_pro_"+ id +".jpg?"+(new Date().getTime());
      else
        return 'http://graph.facebook.com/'
              + id
              + '/picture?type=square&height=175&width=175';
    },
    getImageUrlPicture: function(pImg,id){
      // profile_image
      if(pImg==1)
        return imgBaseUrl+"pro_temp/pro_temp_"+ id +".jpg?"+(new Date().getTime());
      else
        return 'http://graph.facebook.com/'
              + id
              + '/picture?type=square&height=175&width=175';
    },
    getImageUrlSize: function(pImg,id,h,w){
      if(pImg==1)
        return imgBaseUrl+"pro_pic/usr_pro_"+ id +".jpg?"+(new Date().getTime());
      else
        return 'http://graph.facebook.com/' + id
          + '/picture?type=large&height='+h+'&width='+w;
    },
    getImageUrlType: function(pImg,id,type){
      if(pImg==1)
        return imgBaseUrl+"pro_pic/usr_pro_"+ id +".jpg?"+(new Date().getTime());
      else
        return 'http://graph.facebook.com/' + id
          + '/picture?type='+type;
    }
  }
}).factory('ProfileAPI', function($http) {
    return {
        hasVideo:function(userid,fbid,stat){
            // videocheck?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            if(stat != 1)
                stat = 0;
            return $http.get(url + "videocheck?apiKey="+apiKey+"&usrid="+userid+"&ufbid="+fbid+"&state="+stat, { timeout: 5000 }).then(function(response) {
                return response.data;
            });
        },
        setVideoPassword:function(userid,fbid,password,visible_button){
            // videocheck?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            return $http.get(url + "videopasswordupdate?apiKey="+apiKey+"&userid="+userid+"&userfbid="+fbid+"&vpassword="+password+"&visible_button="+visible_button).then(function(response) {
                return response.data;
            });
        },
        checkVideoPassword:function(userid,fbid,password){
            // videocheck?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            return $http.get(url + "checkvideopassword?apiKey="+apiKey+"&userid="+userid+"&userfbid="+fbid+"&vpassword="+password).then(function(response) {
                return response.data;
            });
        },
        checkAstroPassword:function(userid,fbid,password){
            // videocheck?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            return $http.get(url + "checkastropassword?apiKey="+apiKey+"&userid="+userid+"&userfbid="+fbid+"&apassword="+password).then(function(response) {
                return response.data;
            });
        },
        uploadVideo:function(){
            // vzaarsign?apiKey=w347H52d96
            return $http.get(url + "vzaarsign?apiKey="+apiKey).then(function(response) {
                return response.data;
            });
        },
        confirmUploadVideo:function(guid){
            // vzaarprocess?apiKey=w347H52d96&guid=vzd868388104e84e18a872fbe463b28bdb&usrid=1140526&ufbid=1831820984
            return $http.get(url + "vzaarprocess?apiKey="+apiKey+"&guid="+guid+"&usrid="+user.id+"&ufbid="+fbid).then(function(response) {
                return response.data;
            });
        },
        deleteVideo:function(){
            return $http.get(url + "videodelete?apiKey="+apiKey+"&usrid="+user.id+"&ufbid="+fbid).then(function(response) {
                return response.data;
            });
        },
        getMatchProfile: function(fbid,matchID){
            return $http.get(url + "mutualUser?apiKey="+ apiKey + "&fbid=" + fbid + "&degree=1&mufbid=" + matchID, { timeout: 5000 }).then(function(items) {
                return items.data;
            });
        },
        getMatchMakerProfile: function(ffbid,matchFbid){
            return $http.get(url + "matchmakerdata?apiKey=" + apiKey + "&ffbid=" + ffbid + "&mfbid=" + matchFbid + "&ufbid="+fbid, { timeout: 10000 }).then(function(items) {
                return items.data;
            });
        },
        /*getRecommendations: function(){
            return $http.get(url + "getRecommendations?apiKey="+ apiKey + "&fbid=" + fbid).then(function(items) {
                return items.data;
            });
        },*/
        acceptRejectOld: function(fbid,tofbid,ismm,isaccept){
            return $http.get(url + "acceptRejectConnection?apiKey="+ apiKey + "&fromfbid=" + fbid + "&tofbid=" + tofbid + "&ismm=" + ismm + "&isaccept=" + isaccept).then(function(items) {
                return items;
            });
        },
        acceptRejectNew: function(fbid,toid,viaid,stat,app){
            return $http.get(url + "acceptrejectmatchmaker?apiKey="+ apiKey + "&app=" + app + "&stat=" + stat + "&fid=" + fbid + "&toid=" + toid + "&viaid=" + viaid).then(function(items) {
                return items;
            });
        },
        connect: function(ourfbid,matchID){
            /*return $http.get(url + "mutualUser?apiKey="+ apiKey + "&fbid=" + ourfbid + "&degree=1&mufbid=" + matchID).then(function(items) {
                return items;
            });*/
        },
        //userreport?apiKey=w347H52d96&ufbid=100009158363088&rfbid=1052447395&rmessage=%22Lorem%20ipsum%20dolor%20sit%20amet,%20consectetur%20adipiscing%22
        reportProfile: function(rfbid,rmessage){
            return $http.get(url + "userreport?apiKey="+ apiKey + "&ufbid=" + fbid + "&rfbid="+rfbid+"&rmessage=" + encodeURIComponent(rmessage)).then(function(items) {
                return items;
            });
        },
        sendIntroMatchView: function(from,to,via,fname,fid,pref){
            var viaid = null;
            if(via!=null){
                viaid = via;
                via = "&viafbid=" + via;
            }else{
                viaid = null;
                via = '';
            }
            var qstr = '';
            console.log('rating ' + pref);
            if(pref != null){
                //pref = JSON.parse(pref);
                var rating = JSON.parse(pref);
                rating.looks = (rating.looks==true)?1:0
                rating.education = (rating.education==true)?1:0
                rating.caste = (rating.caste==true)?1:0
                rating.location = (rating.location==true)?1:0
                rating.others = (rating.others==true)?1:0
                qstr += "&rating=" + rating.rate;
                qstr += "&looks=" + rating.looks;
                qstr += "&edu=" + rating.education;
                qstr += "&caste=" + rating.caste;
                qstr += "&location=" + rating.location;
                qstr += "&others=" + rating.others;
            }
            var defered = $q.defer();
            if(viaid != null)
                sendMsgtoMatchMM(fid,from,viaid,user.name,fname, function(){
                    $http.get(url + "askintroconnect?apiKey=" + apiKey + "&fromfbid=" + from + "&tofbid=" + to + qstr + via).then(function(items) {
                        console.log(items);
                        if(items.data=="true"){
                            defered.resolve(items);
                        }
                        return items.data;
                    });
                });
            else
                sendMsgtoMatch(fid,from,to,user.name,fname, function(){
                    $http.get(url + "askintroconnect?apiKey=" + apiKey + "&fromfbid=" + from + "&tofbid=" + to + qstr + via).then(function(items) {
                        console.log(items);
                        if(items.data=="true"){
                            defered.resolve(items);
                        }
                        return items.data;
                    });
                });

            return defered.promise;/*$http.get(url + "askintroconnect?apiKey=" + apiKey + "&fromfbid=" + from + "&tofbid=" + to + qstr + via).then(function(items) {
                console.log(items);
                if(items.data=="true"){
                    if(viaid != null)
                        sendMsgtoMatchMM(fid,from,viaid,user.name,fname);
                    else
                        sendMsgtoMatch(fid,from,to,user.name,fname);
                }
                return items.data;
            });*/
        },
        getCaste: function(casteid){
            return $http.get(url + "casteval?apiKey=w347H52d96&casteid="+casteid).success(function(items){
                return items.data;
            });
        },
        getSun: function(sunid){
            return $http.get(url + "sunsign?apiKey=w347H52d96&sunid="+sunid).then(function(items){
                return items.data;
            });
        },
        getStar: function(starid){
            return $http.get(url + "starsign?apiKey=w347H52d96&starid="+starid).success(function(items){
                return items.data;
            });
        },
        isRecommended: function(ffbid){
            return $http.get(url + "recommendlimit?apiKey="+ apiKey + "&ufbid=" + fbid+"&ffbid="+ffbid).success(function(items){
                return items.data;
            });
        },
        submitRecommendation: function(fbid,friendfbid,msg){
            return $http.get(url + "recommendation?apiKey="+ apiKey + "&fromfbid=" + fbid + "&tofbid=" + friendfbid + "&message=" + msg).success(function(items){
                return items.data;
            });
        },
        match: function(fromFBId,toFBId,viaFBId){
            return $http.get(url + "matchmakerintro?apiKey=" + apiKey + "&fromfbid=" + fromFBId + "&tofbid=" + toFBId + "&viafbid=" + viaFBId).success(function(items){
                return items.data;
            });
        },
        sendFBNotification: function(toFBId,text){
            return $http.get(url + "appFBNotification?apiKey=" + apiKey + "&toid=" + toFBId + "&text=" + text).success(function(items){
                return items.data;
            });
        },
        getTweets: function(screenName){
            return $http.get(url + 'tweetsapi?apiKey='+apiKey+'&screen_name='+screenName).then(function(data) {
                return data.data;
            });
        }
    }
}).factory('LoginProcess',function($http){
    return {
        resentEmail: function() { // resendmail?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            return $http.get(url + "resendmail?apiKey="+ apiKey+"&usrid="+user.id+"&ufbid="+getFbID(), { timeout: 5000 }).then(function(response) {
                return response;
            });
        },
        registerGCM: function(regid) { // resendmail?apiKey=w347H52d96&usrid=1140526&ufbid=1831820984
            return $http.get(url + "registergcm?apiKey="+ apiKey+"&user_id="+user.id+"&regid="+regid).then(function(response) {
                return response;
            });
        },
        getOrSetUser: function(fbid, accessToken) {
            $http.get(url + "matmobload?apiKey="+ apiKey + "&ufbId="+fbid, { timeout: 200 })
                    .success(function(){console.log('getOrSetUser Success');})
                    .error(function(){console.log('getOrSetUser failure');});
            return $http.get(url+"user?apiKey="+ apiKey + "&fbid=" + fbid + "&accessToken=" + accessToken).then(function(response) {
                //Process Stuff Here
                setUserData(response);
                return response;
            });
        },
        getMessageCounts: function() {
            //url + "messagenoti?apiKey="+ apiKey + "&ufbid=" + ufbid
            //url + "noticount?apiKey="+ apiKey + "&fbid=" + fbid
            return $http.get(url + "messagenoti?apiKey="+ apiKey + "&ufbid=" + fbid).then(function(response) {
                //console.log('messagenoti '+response.data);
                return response.data;
            });
        },
        getNotificationCounts: function(){
            return $http.get(url + "noticount?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                console.log('noticount '+response.data);
                return response.data;
            });
        },

        getAboutme: function() {
            //url + "messagenoti?apiKey="+ apiKey + "&ufbid=" + ufbid
            //url + "noticount?apiKey="+ apiKey + "&fbid=" + fbid
            return $http.get(url + "getaboutme?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                console.log('aboutme '+response.data);
                return response.data;
            });
        },
        isBlocked: function(fbid, indata) {
            return $http.get(url + "getBlockStat?apiKey="+ apiKey + "&userfbid=" + fbid).then(function(response) {
                //Process Stuff Here
                return response;
            });
        },
        updateUserDataBackground: function(fbid, accessToken){
            $http.get(url + "matmobload?apiKey="+ apiKey + "&ufbId="+fbid, { timeout: 100 })
                    .success(function(){console.log('getOrSetUser Success');})
                    .error(function(){console.log('getOrSetUser failure');});
            return $http.get(url+"user?apiKey="+ apiKey + "&fbid=" + fbid + "&accessToken=" + accessToken).then(function(response) {
                //Process Stuff Here
                console.log(JSON.stringify(response));
                setUserData(response);
                user = response;
                // user = response;
                return response;
            });
        },
        updateUserLocation: function(fbid,lat,longi){
            console.log('location update');
            return $http.get(url + "updatelocation?apiKey="+ apiKey +"&fbId=" + fbid + "&lat=" + lat + "&long=" + longi).then(function(response) {
                return response;
            });
        }
    };
}).factory('ChatMessageFactory',function($http){
    return{
        getMessages: function(tofbid,page,pagesize) {
            // getMessage?apiKey=w347H52d96&fid=100009158363088&tid=1831820984&page=%201&pagesize=20
            return $http.get(url + "getMessage?apiKey="+ apiKey + "&fid=" + fbid + "&tid=" + tofbid + "&page=" + page + "&pagesize=" + pagesize).then(function(response) {
                //Process Stuff Here
                return response;
            });
        },
        sendMessage: function(toid,msg){
            return $http.get(url + "saveMessage?apiKey="+ apiKey + "&fid=" + fbid + "&tid=" + toid + "&msg=" + msg).then(function(response) {
                //Process Stuff Here
                return response;
            });
        },
        readMessage: function(toid){
            return $http.get(url + "setmsgread?apikey="+apiKey+"&fromid="+fbid+"&toid="+toid).then(function(response){
                return response;
            });
            /*return $http.get(urlLink + "setmsgstat/"+toid+"/"+fbid).then(function(response){
                return response;
            });*/
        }
    };
}).factory('ChatListingFactory',function($http){
    return{
        getConnections: function(fbid) {
            return $http.get(url + "getConnections?apiKey="+ apiKey + "&fbid=" + fbid,{ timeout: 3000 }).then(function(response) {
                //Process Stuff Here
                return response.data;
            });
        },
        getRequestChat: function(fbid) {
            return $http.get(url + "unconmess?apiKey="+ apiKey + "&fbid=" + fbid,{ timeout: 3000 }).then(function(response) {
                //Process Stuff Here
                return response.data;
            });
        },
        getOnlineUsers: function(){
            return $http.get(url+"usersonline?apiKey="+apiKey+"&ufbid="+fbid,{ timeout: 3000 }).then(function(response){
                return response.data;
            });
        }
    };
}).factory('ConnectionsFactory',function($http){
    return {
        getConnections: function(fbid) {
            return $http.get(url + "getConnections?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                return response.data;
            });
        },
        getPendingConnections: function(fbid) {
            // pendreq?apiKey=w347H52d96&fbId=1831820984
            return $http.get(url + "pendreq?apiKey="+ apiKey + "&fbId=" + fbid).then(function(response) {
                return response.data;
            });
        },
        getCancelPendingConnections: function(fbid,reqId) {
            return $http.get(url + "trashconn?apiKey="+ apiKey + "&fbId=" + fbid + "&reqId=" + reqId).then(function(response) {
                return response.data;
            });
        },
        getCancelConnections: function(rfbid){
            // approveremove?apiKey=w347H52d96&ufbid=&rfbid=
            return $http.get(url + "approveremove?apiKey="+ apiKey + "&ufbid=" + fbid + "&rfbid=" + rfbid).then(function(response) {
                return response.data;
            });
        },
        getRecommendations: function(fbid) {
            return $http.get(url + "getRecommendations?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                return response.data;
            });
        },
        acceptRejectRecommendations: function(recId,ar){
            return $http.get(url + "acceptRejectRecommend?apiKey="+ apiKey + "&id=" + recId + "&isaccept=" + ar).then(function(response) {
                //Process Stuff Here
                return response;
            });
        }
    };
}).factory('NotificationsFactory',function($http){
    return{
        /*getYouTabValues: function(fbid) {
            return $http.get(url + "getNewConnection?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                //Process Stuff Here
                return response;
            });
        },*/
        notificationRead: function(nid) {
            return $http.get(url + "notifyflush?apiKey="+apiKey+"&nid="+nid).then(function(response) {
                //Process Stuff Here
                return response;
            });
        },
        getMatchmakerTabValues: function(fbid) {
            //https://testv3.spouseup.com/spousev3/public/api/v1/usernoties?apiKey=w347H52d96&fbid=1831820984
            return $http.get(url + "usernoties?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                return response;
            });
        },
        getFriendTabValues: function(recId,ar){
            return $http.get(url + "friendnoties?apiKey="+ apiKey + "&fbid=" + fbid).then(function(response) {
                //Process Stuff Here
                var regex = /(<([^>]+)>)/ig;
                var str = JSON.stringify(response).replace(regex, "");
                var friendNotifications = JSON.parse(str);
                return friendNotifications;
            });
        }
    };
}).factory('SearchFactory',function($http){
    return{
        getCastes: function() {
            return $http.get(url + "getCaste?apiKey="+ apiKey).then(function(response) {
                return response.data;
            });
        },
        getMotherTongue: function() {
            return $http.get(url + "getMotherTongue?apiKey="+ apiKey).then(function(response) {
                return response.data;
            });
        },
        getOnlineUsers: function(fbid,page) {
            page = page == undefined? '' : page;

            return $http.get(url + "onlineusers?apiKey="+ apiKey + "&fbid=" + fbid + "&page=" + page + "&pagesize=10", { timeout: 20000 }).then(function(response) {
                return response.data;
            });
        },
        search: function(fbid,relid,casid,town,mothertongue,ageFrom,ageTo,page) {
            relid = relid == undefined? '' : relid;
            casid = casid == undefined? '' : casid;
            town = town == undefined? '' : town;
            mothertongue = mothertongue == undefined? '' : mothertongue;
            ageFrom = ageFrom == undefined? '' : ageFrom;
            ageTo = ageTo == undefined? '' : ageTo;
            page = page == undefined? '' : page;

            return $http.get(url + "getSearch?apiKey="+ apiKey + "&fbid=" + fbid+"&relid="+relid+"&casid="+casid+"&town="+town+"&mothertongue="+mothertongue+"&ageStart="+ageFrom+"&ageEnd="+ageTo+"&page="+page+"&pagesize=10", { timeout: 20000 }).then(function(response) {
                return response.data;
            });
        },
        locationSearch: function(fbid,lat,long,location,distance,locationSearchPageNo) {
            return $http.get(url + "geosearch?apiKey="+ apiKey + "&fbId=" + fbid+"&lat="+lat+"&long="+long+"&distance="+distance+"&location="+location+"&page="+locationSearchPageNo+"&pagesize=10", { timeout: 5000 }).then(function(response) {
                return response.data;
            });
        }
    };
}).factory('MatchmakerListing',function($http){
    return {
        getSingleFriends: function(singlePageNo) {
            return $http.get(url + "friendsingle?apiKey="+ apiKey + "&ufbid=" + fbid + "&pagesize=20&page="+singlePageNo).then(function(response) {
                return response;
            });
        },
        getSingleMatches: function(ufbid,ffbid,makerPageNo) {
            return $http.get(url + "matchesnew?apiKey="+ apiKey + "&ufbid=" + ufbid + "&mfbid=" + ffbid + "&page=" +  makerPageNo + "&pagesize=9").then(function(response) {
                return response;
            });
        }
    };
}).factory('UpdateProfile',function($http){

    return {
        getProfileDetails: function() {
            return $http.get(url + "getProfileNew?apiKey="+ apiKey+"&fbid="+user.user_fb_id+"&userid="+user.id, { timeout: 10000 }).then(function(response) {

                return response.data;
            });

        },
        uploadImageSrc: function(fbid,source) {
            return $http.get(url + "photofetch?apiKey="+ apiKey +"&fbId=" + fbid + "&src=" + encodeURIComponent(source)).then(function(response) {
                return response.data;
            });
        },
        updateProfile: function(userID,fbid, dob, religionId, casteId,statusId,currentLoc,mobile,aboutme,gothra,lang,mothertongue,email,home_town,country) {
            console.log('#295 '+userID+' '+fbid+' '+dob+' '+religionId+' '+casteId+' '+statusId+' '+currentLoc+' '+mobile+' '+aboutme+' '+gothra+' '+lang);
            religionId = (religionId == undefined || religionId == null)?'':religionId;
            casteId = (casteId == undefined || casteId == null)?'':casteId;
            statusId = (statusId == undefined || statusId == null)?'':statusId;
            currentLoc = (currentLoc == undefined || currentLoc == null)?'':currentLoc;
            mobile = (mobile == undefined || mobile == null)?'':mobile;
            console.log("inside web api fac:" +aboutme);
            aboutme = (aboutme == undefined || aboutme == null)?'':aboutme;
            gothra = (gothra == undefined || gothra == null)?'':gothra;
            lang = (lang == undefined || lang == null)?'':lang;
            mothertongue = (mothertongue == undefined || mothertongue == null)?'':mothertongue;
            email = (email == undefined || email == null)?'':email;
            home_town = (home_town == undefined || home_town == null)?'':home_town;
            if(typeof country == "string")
                country = country.trim();
            country = (country == undefined || country == null)?'':country;
            return $http.get(url + "updateProfile?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&dob=" + dob + "&religionId=" + religionId + "&casteId=" + casteId + "&statusId=" + statusId +"&currentLoc="+currentLoc+"&mobile="+mobile+"&aboutme="+aboutme+"&gothra="+gothra+"&lang="+lang+"&mother_tongue="+mothertongue+"&email="+email+"&home_town="+home_town+"&country="+country).then(function(response) {
                user.dob = dob;
                user.caste_id = casteId;
                user.religion_id = religionId;
                console.log(JSON.stringify(response));
                return response.data;
            });
        },
        physicalUpdate: function(userID,fbid,feet,inch,weight,body,skin,phystat) {
            feet = (feet == undefined || feet == null)?'':feet;
            inch = (inch == undefined || inch == null)?'':inch;
            weight = (weight == undefined || weight == null)?'':weight;
            body = (body == undefined || body == null)?'':body;
            skin = (skin == undefined || skin == null)?'':skin;
            phystat = (phystat == undefined || phystat == null)?'':phystat;
            return $http.get(url + "physicalUpdate?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&feet=" + feet + "&inch=" + inch + "&weight=" + weight + "&body=" + body +"&skin="+skin+"&phystat="+phystat).then(function(response) {
                return response.data;
            });
        },
        familyUpdate: function(userID,fbid,famstat,famtype,famval) {
            famstat = (famstat == undefined || famstat == null)?'':famstat;
            famtype = (famtype == undefined || famtype == null)?'':famtype;
            famval = (famval == undefined || famval == null)?'':famval;
            return $http.get(url + "familyUpdate?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&famstat=" + famstat + "&famtype=" + famtype + "&famval=" + famval).then(function(response) {
                return response.data;
            });
        },
        habitUpdate: function(userID,fbid,food,drink,smoke) {
            food = (food == undefined || food == null)?'':food;
            drink = (drink == undefined || drink == null)?'':drink;
            smoke = (smoke == undefined || smoke == null)?'':smoke;
            return $http.get(url + "habitUpdate?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&food=" + food + "&drink=" + drink+ "&smoke=" + smoke).then(function(response) {
                return response.data;
            });
        },
        astroUpdate: function(userID,fbid,chevvai,sun,star,birthplace,hr,min,meridiem,astronote) {
            chevvai = (chevvai == undefined || chevvai == null)?'':chevvai;
            sun = (sun == undefined || sun == null)?'':sun;
            star = (star == undefined || star == null)?'':star;
            birthplace = (birthplace == undefined || birthplace == null)?'':birthplace;
            hr = (hr == undefined || hr == null)?'':hr;
            min = (min == undefined || min == null)?'':min;
            meridiem = (meridiem == undefined || meridiem == null)?'':meridiem;
            astronote = (astronote == undefined || astronote == null)?'':astronote;

            return $http.get(url + "astroUpdate?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&chevvai=" + chevvai + "&sun=" + sun+ "&star=" + star + "&birthplace=" + birthplace + "&birthhour=" + hr + "&birthmin=" + min + "&birthmeridiem=" + meridiem+ "&astronote=" + astronote).then(function(response) {
                return response.data;
            });
        },
        removeHoroscope: function() {
            return $http.get(url + "astroimgrem?apiKey="+apiKey+"&userid="+user.id).then(function(response) {
                return response.data;
            });
        },
        professionUpdate: function(userID,fbid,profession,employedin,monthlyin,highedu,eduinst) {
            profession = (profession == undefined || profession == null)?'':profession;
            employedin = (employedin == undefined || employedin == null)?'':employedin;
            monthlyin = (monthlyin == undefined || monthlyin == null)?'':monthlyin;
            highedu = (highedu == undefined || highedu == null)?'':highedu;
            eduinst = (eduinst == undefined || eduinst == null)?'':eduinst;

            return $http.get(url + "professionalUpdate?apiKey="+ apiKey +"&userid="+ userID +"&fbid=" + fbid + "&profession=" + encodeURIComponent(profession) + "&employedin=" + encodeURIComponent(employedin) + "&monthlyin=" + encodeURIComponent(monthlyin) + "&highedu=" + encodeURIComponent(highedu) + "&eduinst=" + encodeURIComponent(eduinst)).then(function(response) {
                return response.data;
            });
        },
        updateRole: function(fbid,dob,gender,email,statusId,religionId,casteId,coupon,cur_loc,country) { // ,home_town
            statusId = (statusId == undefined || statusId == null)?'':statusId;
            var findMatch = 1;
            if(statusId == 4){
                dob = null;
                gender = null;
                findMatch = 0;
            }else{
                findMatch = 1;
            }
            var extras = "";
            // if(isgoogle){
            //     extras = "&isgoogle=1&home_town="+home_town;
            // }
            if(typeof country == "string")
                country = country.trim();
            if(coupon == undefined)
                coupon = '';
            return $http.get(url + "saveConfirm?apiKey="+ apiKey + "&fbid=" + user.user_fb_id + "&findMatch=" + findMatch + "&beMatch=1&dob=" + dob + "&gender=" + gender + "&email=" + email + "&statusId=" + statusId + "&religionId=" + religionId + "&casteId=" + casteId +"&coupon="+coupon+"&cur_loc="+cur_loc+"&country="+country).then(function(data) {
                user.dob = dob;
                user.is_find_match = findMatch;
                user.is_match_maker = 1;
                user.gender = gender;
                user.email = email;
                user.religion_id = religionId;
                user.caste_id = casteId;
                user.relationship_id = statusId;
                setUserData(user);
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        updateLinkedIn: function(linkedinUserID,linkedinAccessToken) {
            return $http.get(url + 'linkedingen?apiKey='+ apiKey +'&usrid='+linkedinUserID+'&access_token='+linkedinAccessToken).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        updateTwitter: function(twitterUserID,twitterID) {
            return $http.get(url + 'twittergen?apiKey='+ apiKey +'&usrid='+twitterUserID+'&twitter_id='+twitterID).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        removeLinkedIn: function(usrId) {
            return $http.get(url + 'linkedinrem?apiKey='+ apiKey +'&usrId='+usrId).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        removeTwitter: function(usrId) {
            return $http.get(url + 'twitterrem?apiKey='+ apiKey +'&usrId='+usrId).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        albumUpdate: function(imgsrc,state){
            return $http.get(url + 'portimage?apiKey='+ apiKey +'&uid='+user.id +'&ufbid='+user.user_fb_id +'&imgsrc='+encodeURIComponent(imgsrc) +'&state='+state).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        },
        removeFromAlbum: function(state){
            return $http.get(url + 'portremove?apiKey='+ apiKey +'&uid='+user.id +'&ufbid='+user.user_fb_id +'&state='+state).then(function(data) {
                console.log(JSON.stringify(data));
                return data.data;
            });
        }

    };
}).factory('TwitterService', function($cordovaOauth, $cordovaOauthUtility, $http, $q) {
    // 1
    var twitterKey = "STORAGE.TWITTER.KEY";
    var clientId = 'eNQYq8QaeSk43En6MWWM0Ge2p';//<SUD>'887NgE5Pcuz4tuxJY5aRJEUW3';//<MAIN ID>'eNQYq8QaeSk43En6MWWM0Ge2p';
    var clientSecret = 'IBP82rwrUssZFNOWmMVj58Qksr4TzaBBnMOODN5VwhtmQzuJbn';//<SUD>'D9PstyQwdXsVPHq2fvTeXClCwMxkgVrRgAmtLVBhnxqO59sfc5';//<MAIN SECRET>'IBP82rwrUssZFNOWmMVj58Qksr4TzaBBnMOODN5VwhtmQzuJbn';

    // 2
    function storeUserToken(data) {
        window.localStorage.setItem(twitterKey, JSON.stringify(data));
    }

    function getStoredToken() {
        return window.localStorage.getItem(twitterKey);
    }

    // 3
    function createTwitterSignature(method, url) {
        var token = angular.fromJson(getStoredToken());
        var oauthObject = {
            oauth_consumer_key: clientId,
            oauth_nonce: $cordovaOauthUtility.createNonce(10),
            oauth_signature_method: "HMAC-SHA1",
            oauth_token: token.oauth_token,
            oauth_timestamp: Math.round((new Date()).getTime() / 1000.0),
            oauth_version: "1.0"
        };
        var signatureObj = $cordovaOauthUtility.createSignature(method, url, oauthObject, {}, clientSecret, token.oauth_token_secret);
        $http.defaults.headers.common.Authorization = signatureObj.authorization_header;
        return $http;
    }

    return {
        // 4
        initialize: function() {
            var deferred = $q.defer();
            var token = getStoredToken();

            console.log('inside initialize');
            console.log('twitter token ' + token);

            if (token !== null) {
                deferred.resolve(true);
            } else {
                console.log('token null');
                $cordovaOauth.twitter(clientId, clientSecret).then(function(result) {
                    console.log('cordovaOauth');
                    console.log('result ' + result);
                    storeUserToken(result);
                    deferred.resolve(true);
                }, function(error) {
                    deferred.reject(false);
                });
            }
            return deferred.promise;
        },
        // 5
        isAuthenticated: function() {
            return getStoredToken() !== null;
        },
        // 6
        getHomeTimeline: function() {
            var home_tl_url = 'https://api.twitter.com/1.1/statuses/home_timeline.json';
            return createTwitterSignature('GET', home_tl_url);
            //return $resource(home_tl_url).query();
        },
        storeUserToken: storeUserToken,
        getStoredToken: getStoredToken,
        createTwitterSignature: createTwitterSignature
    };
});